#pragma once
#include "YoggieEngine.h"

namespace YoggieEngine {
	// forward declaration
	class InputManager;

	class Application {
	public:
		Application(const std::string& name);
		virtual void Run();


	protected:
		std::string m_AppName;
		Renderer* renderer = nullptr;
		InputManager* InputSystem = nullptr;
		friend class ApplicationRuntime;
	};


	class ApplicationRuntime {

	public:
		virtual void Start() = 0;
		virtual void Update() = 0;
		virtual void FixedUpdate() = 0;
		virtual void Stop() = 0;

	};


};
